#ifndef BOOLEAN_H
#define BOOLEAN_H

#define BBini(bb)                (bb).p[0] = (bb).p[1] = (bb).p[2] = 0
#define BBToU(bb)                ((bb).p[0] | (bb).p[1] | (bb).p[2])
#define BBToUShift(bb)           ((bb).p[0]<<2 | (bb).p[1]<<1 | (bb).p[2])
#define BBCmp(bb1,bb2)           ( (bb1).p[0] != (bb2).p[0]                   \
				   || (bb1).p[1] != (bb2).p[1]                \
				   || (bb1).p[2] != (bb2).p[2] )
#define BBNot(bb,bb1)            (bb).p[0] = ~(bb1).p[0],                     \
                                 (bb).p[1] = ~(bb1).p[1],                     \
                                 (bb).p[2] = ~(bb1).p[2]
#define BBOr(bb,bb1,bb2)         (bb).p[0] = (bb1).p[0] | (bb2).p[0],         \
                                 (bb).p[1] = (bb1).p[1] | (bb2).p[1],         \
                                 (bb).p[2] = (bb1).p[2] | (bb2).p[2]
#define BBAnd(bb,bb1,bb2)        (bb).p[0] = (bb1).p[0] & (bb2).p[0],         \
                                 (bb).p[1] = (bb1).p[1] & (bb2).p[1],         \
                                 (bb).p[2] = (bb1).p[2] & (bb2).p[2]
#define BBXor(bb,b1,b2)          (bb).p[0] = (b1).p[0] ^ (b2).p[0],           \
                                 (bb).p[1] = (b1).p[1] ^ (b2).p[1],           \
                                 (bb).p[2] = (b1).p[2] ^ (b2).p[2]
#define BBAndOr(bb,bb1,bb2)      (bb).p[0] |= (bb1).p[0] & (bb2).p[0],        \
                                 (bb).p[1] |= (bb1).p[1] & (bb2).p[1],        \
                                 (bb).p[2] |= (bb1).p[2] & (bb2).p[2]
#define BBNotAnd(bb,bb1)         bb.p[0] &= ~bb1.p[0];                        \
                                 bb.p[1] &= ~bb1.p[1];                        \
                                 bb.p[2] &= ~bb1.p[2]
#define BBContractShift(bb1,bb2) ( ( (bb1).p[0] & (bb2).p[0] ) << 2           \
                                     | ( (bb1).p[1] & (bb2).p[1] ) << 1       \
                                     | ( (bb1).p[2] & (bb2).p[2] ) )
#define BBContract(bb1,bb2)      ( ( (bb1).p[0] & (bb2).p[0] )                \
                                     | ( (bb1).p[1] & (bb2).p[1] )            \
                                     | ( (bb1).p[2] & (bb2).p[2] ) )
#define PopuCount0(i,u)          for ( i=0; u; i++ ) { u &= u-1U; }
#define PopuCount0a(i,u)         for ( i=0;; i++ ) { u &= u-1U;               \
                                                     if ( ! u ) { break; } }
#define PopuCount0NB(i,u)        u -= (u>>1) & 0x55555555U;                   \
                                 u  = ((u>>2) & 0x33333333U)                  \
                                       + (u & 0x33333333U);                   \
                                 u  = ((u>>4) + u) & 0x0f0f0f0fU;             \
                                 u += u >> 8;                                 \
                                 u += u >>16;                                 \
                                 i  = u & 0x0000003fU
#define PopuCount0aNB(i,u)       u -= (u>>1) & 0x55555555U;                   \
                                 u  = ((u>>2) & 0x33333333U)                  \
                                       + (u & 0x33333333U);                   \
                                 u  = ((u>>4) + u) & 0x0f0f0f0fU;             \
                                 u += u >> 8;                                 \
                                 u += u >>16;                                 \
                                 i  = ( u & 0x0000003fU ) - 1U
#define first_one(bb)            first_one012( bb.p[0], bb.p[1], bb.p[2] )
#define last_one(bb)             last_one210( bb.p[2], bb.p[1], bb.p[0] )
#define PopuCount(bb)            popu_count012( bb.p[0], bb.p[1], bb.p[2] )

int popu_count012( unsigned int u0, unsigned int u1, unsigned int u2 );

#if defined(_MSC_VER) || defined(__ICC)

int first_one012( unsigned int u0, unsigned int u1, unsigned int u2 );
int last_one210( unsigned int u2, unsigned int u1, unsigned int u0 );
int first_one01( unsigned int u0, unsigned int u1 );
int first_one12( unsigned int u1, unsigned int u2 );
int last_one01( unsigned int u0, unsigned int u1 );
int last_one12( unsigned int u1, unsigned int u2 );
int first_one1( unsigned int u1 );
int first_one2( unsigned int u2 );
int last_one0( unsigned int u0 );
int last_one1( unsigned int u1 );

#elif defined(__GNUC__) && defined(__i386)

static inline int
first_one012( unsigned int u0, unsigned int u1, unsigned int u2 )
{
  int itemp;

  asm ( "    bsr   %2,  %1  \n\t"
        "    movl  $26, %0  \n\t"
        "    jnz   1f       \n\t"
        "    bsr   %3,  %1  \n\t"
        "    movl  $53, %0  \n\t"
        "    jnz   1f       \n\t"
        "    bsr   %4,  %1  \n\t"
        "    movl  $80, %0  \n\t"
        "1:  subl  %1,  %0  \n\t"
	: "=&r" ( u0 ), "=&r" ( itemp ) : "0" ( u0 ), "g" ( u1 ), "g" ( u2 ) );

  return u0;
}


static inline int
last_one210( unsigned int u2, unsigned int u1, unsigned int u0 )
{
  int itemp;

  asm ( "    bsf   %2,  %1  \n\t"
	"    movl  $80, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsf   %3,  %1  \n\t"
	"    movl  $53, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsf   %4,  %1  \n\t"
	"    movl  $26, %0  \n\t"
	"1:  subl  %1,  %0  \n\t"
	: "=&r" ( u2 ), "=&r" ( itemp ) : "0" ( u2 ), "g" ( u1 ), "g" ( u0 ) );

  return u2;
}


static inline int
first_one01( unsigned int u0, unsigned int u1 )
{
  int itemp;

  asm ( "    bsr   %2,  %1  \n\t"
	"    movl  $26, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsr   %3,  %1  \n\t"
	"    movl  $53, %0  \n\t"
	"1:  subl  %1,  %0  \n\t"
	: "=&r" ( u0 ), "=&r" ( itemp ) : "0" ( u0 ), "g" ( u1 ) );

  return u0;
}


static inline int
first_one12( unsigned int u1, unsigned int u2 )
{
  int itemp;

  asm ( "    bsr   %2,  %1  \n\t"
	"    movl  $53, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsr   %3,  %1  \n\t"
	"    movl  $80, %0  \n\t"
	"1:  subl  %1,  %0  \n\t"
	: "=&r" ( u1 ), "=&r" ( itemp ) : "0" ( u1 ), "g" ( u2 ) );

  return u1;
}


static inline int
last_one01( unsigned int u0, unsigned int u1 )
{
  int itemp;

  asm ( "    bsf   %2,  %1  \n\t"
	"    movl  $53, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsf   %3,  %1  \n\t"
	"    movl  $26, %0  \n\t"
	"1:  subl  %1,  %0  \n\t"
	: "=&r" ( u1 ), "=&r" ( itemp ) : "0" ( u1 ), "g" ( u0 ) );

  return u1;
}


static inline int
last_one12( unsigned int u1, unsigned int u2 )
{
  int itemp;

  asm ( "    bsf   %2,  %1  \n\t"
	"    movl  $80, %0  \n\t"
	"    jnz   1f       \n\t"
	"    bsf   %3,  %1  \n\t"
	"    movl  $53, %0  \n\t"
	"1:  subl  %1,  %0  \n\t"
	: "=&r" ( u2 ), "=&r" ( itemp ) : "0" ( u2 ), "g" ( u1 ) );

  return u2;
}


static inline int
first_one1( unsigned int u1 )
{
  int itemp;

  asm ( "    bsr     %2,  %1  \n\t"
	"    movl    $53, %0  \n\t"
	"    subl    %1,  %0  \n\t"
	: "=r" ( u1 ), "=r" ( itemp ) : "0" ( u1 ) );

  return u1;
}


static inline int
first_one2( unsigned int u2 )
{
  int itemp;

  asm ( "    bsr     %2,  %1  \n\t"
	"    movl    $80, %0  \n\t"
	"    subl    %1,  %0  \n\t"
	: "=r" ( u2 ), "=r" ( itemp ) : "0" ( u2 ) );

  return u2;
}


static inline int
last_one0( unsigned int u0 )
{
  int itemp;

  asm ( "    bsf     %2,  %1  \n\t"
	"    movl    $26, %0  \n\t"
	"    subl    %1,  %0  \n\t"
	: "=r" ( u0 ), "=r" ( itemp ) : "0" ( u0 ) );

  return u0;
}


static inline int
last_one1( unsigned int u1 )
{
  int itemp;

  asm ( "   bsf     %2,  %1  \n\t"
	"   movl    $53, %0  \n\t"
	"   subl    %1,  %0  \n\t"
	: "=r" ( u1 ), "=r" ( itemp ) : "0" ( u1 ) );

  return u1;
}

#else

int last_one210( unsigned int u2, unsigned int u1, unsigned int u0 );
int first_one012( unsigned int u0, unsigned int u1, unsigned int u2 );
int first_one01( unsigned int u0, unsigned int u1 );
int first_one12( unsigned int u1, unsigned int u2 );
int last_one01( unsigned int u0, unsigned int u1 );
int last_one12( unsigned int u1, unsigned int u2 );

static inline int
first_one1( unsigned int u1 )
{
  if ( u1 & 0x7fc0000U ) { return aifirst_one[u1>>18] + 27; }
  if ( u1 & 0x7fffe00U ) { return aifirst_one[u1>> 9] + 36; }
  return aifirst_one[u1] + 45;
}

static inline int
first_one2( unsigned int u2 )
{
  if ( u2 & 0x7fc0000U ) { return aifirst_one[u2>>18] + 54; }
  if ( u2 & 0x7fffe00U ) { return aifirst_one[u2>> 9] + 63; }
  return aifirst_one[u2] + 72;
}

static inline int
last_one0( unsigned int i )
{
  unsigned int j;

  j = i & 0x00001ffU;  if ( j ) { return ailast_one[j    ] + 18; }
  j = i & 0x003ffffU;  if ( j ) { return ailast_one[j>> 9] +  9; }
  return ailast_one[i>>18];
}

static inline int
last_one1( unsigned int u1 )
{
  unsigned int j;

  j = u1 & 0x00001ffU;  if ( j ) { return ailast_one[j    ] + 45; }
  j = u1 & 0x003ffffU;  if ( j ) { return ailast_one[j>> 9] + 36; }
  return ailast_one[u1>>18] + 27;
}

#endif

#endif /* BOOLEAN_H */
